﻿using System;

namespace MaciejGrabek.WP7Accelerometer
{
    public class WP7AccelerometerReadingEventArgs : EventArgs
    {
        private double _x;
        private double _y;
        private double _z;
        private DateTimeOffset _timestamp;

        public WP7AccelerometerReadingEventArgs(double x, double y, double z, DateTimeOffset timestamp)
        {
            _x = x;
            _y = y;
            _z = z;
            _timestamp = timestamp;
        }

        // Summary:
        //     A timestamp indicating the time at which the accelerometer reading was taken.
        //
        // Returns:
        //     Type: System.DateTimeOffset.
        public DateTimeOffset Timestamp { get { return _timestamp; } }
        //
        // Summary:
        //     The acceleration in the X direction.
        //
        // Returns:
        //     Type: System.Double.
        public double X { get { return _x; } }
        //
        // Summary:
        //     The acceleration in the Y direction.
        //
        // Returns:
        //     Type: System.Double.
        public double Y { get { return _y; } }
        //
        // Summary:
        //     The acceleration in the Z direction.
        //
        // Returns:
        //     Type: System.Double.
        public double Z { get { return _z; } }
    }
}
