﻿using System;
using System.Windows.Controls;
using MaciejGrabek.WP7Accelerometer;
using Microsoft.Phone.Controls;

namespace MaciejGrabek.WP7AccelerometerEmulatorDemo
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();

            var acc = new WP7AccelerometerProvider();
            acc.ReadingChanged += OnAccelerometerProviderReadingChanged;

            try
            {
                acc.Start();
            }
            catch (Exception exc)
            {
                txtblk.Text = exc.Message;
            }
        }

        private void OnAccelerometerProviderReadingChanged(object sender, WP7AccelerometerReadingEventArgs args)
        {
            ProcessAccelerometerData(args.X, args.Y, args.Z, args.Timestamp);
        }

        private void ProcessAccelerometerData(double x, double y, double z, DateTimeOffset timestamp)
        {
            string str = String.Format("X = {0:F2}\n" +
                                       "Y = {1:F2}\n" +
                                       "Z = {2:F2}\n\n" +
                                       "Magnitude = {3:F2}\n\n" +
                                       "{4}",
                                       x, y, z,
                                       Math.Sqrt(x * x + y * y + z * z),
                                       timestamp);

            if (txtblk.CheckAccess())
            {
                SetTextBlockText(txtblk, str);
            }
            else
            {
                txtblk.Dispatcher.BeginInvoke(new SetTextBlockTextDelegate(SetTextBlockText),
                                              txtblk, str);
            }
        }

        delegate void SetTextBlockTextDelegate(TextBlock txtblk, string text);

        void SetTextBlockText(TextBlock txtblk, string text)
        {
            txtblk.Text = text;
        }
    }
}