﻿using System.ServiceModel.Activation;
using MaciejGrabek.WP7AccelerometerEmulatorProxy.Model;
using System.Web;
using System;
using System.Web.Caching;

namespace MaciejGrabek.WP7AccelerometerEmulatorProxy
{
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class AccelerometerEmulatorProxy : IAccelerometerEmulatorProxy
    {
        public string GetData()
        {
            AccelerometerVector v = HttpRuntime.Cache[AccelerometerVector.CacheKey] as AccelerometerVector;
            if (v != null)
            {
                return v.ToString();
            }
            else
            {
                return AccelerometerVector.Empty.ToString();
            }
        }

        public void SetData(float x, float y, float z)
        {
            AccelerometerVector v = new AccelerometerVector()
            {
                X = x,
                Y = y,
                Z = z
            };
            HttpRuntime.Cache.Remove(AccelerometerVector.CacheKey);
            HttpRuntime.Cache.Add(AccelerometerVector.CacheKey,
                v,
                null,
                DateTime.MaxValue,
                Cache.NoSlidingExpiration,
                CacheItemPriority.Default,
                delegate { });
        }

    }
}
