﻿using System;
using Microsoft.Xna.Framework;

namespace MaciejGrabek.WP7AccelerometerEmulatorUI.Logic
{
    public class GForceCalculator
    {
        public static Vector3 Calculate(float rX, float rY, float rZ)
        {
            /// "Yaw" alphaY
            /// "Pitch" alphaX
            /// "Roll" alphaZ
            Vector3 g = new Vector3(0, 0, -1);
            Quaternion q = Quaternion.CreateFromYawPitchRoll(
                DegreesToRadians(rY),
                DegreesToRadians(rX),
                DegreesToRadians(rZ));
            Vector3 transformed = Vector3.Transform(g, q);
            transformed.X = -transformed.X;
            transformed.Y = -transformed.Y;
            return transformed;
        }

        private static float DegreesToRadians(float degrees) { return degrees * (float)Math.PI / 180f; }
    }
}
